package guanlixitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/enterprise/src/guanlixitong/model"
)

type resume struct {
	interview interview
	Table
	fields          string `data:"avatar,name,info,nick,wechat,city,age,work,mobile,email,degree,school,major,year,link,recruitment_uid"`
	create          string `name:"create name* info nick wechat mobile email degree school major" role:"leader"`
	remove          string `name:"remove" role:"leader"`
	interviewInsert string `name:"create title* content begin_time*:select@date end_time*:select@date address" role:"leader"`
}

func (s resume) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.TITLE:
		m.Push(arg[0], "一面")
		m.Push(arg[0], "二面")
		m.Push(arg[0], "三面")
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s resume) List(m *ice.Message, arg ...string) {
	s.ValueList(m, arg).Table(func(value ice.Maps) {
		m.PushButton(s.InterviewInsert)
	}).Action().Display("")
	s.SelectJoin(m, recruitment{}, model.TITLE)
	if len(arg) == 1 {
		m.Sort("degree,age", []string{"博士", "硕士", "本科", "专科"}, ice.INT)
	}
}
func (s resume) Upload(m *ice.Message, arg ...string) {
	m.Echo(kit.MergeURL("/p/"+m.UploadSave("usr/image/"), ice.POD, m.Option(ice.MSG_USERPOD)))
}
func (s resume) InterviewInsert(m *ice.Message, arg ...string) {
	m.Cmdy(s.interview, s.interview.Insert, arg, m.OptionSimple(model.GROUP_UID, model.USER_UID))
}

func init() { ice.TeamCtxCmd(resume{}) }
