package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID               = "uid"
	NAME              = "name"
	INFO              = "info"
	TYPE              = "type"
	TITLE             = "title"
	CONTENT           = "content"
	BEGIN_TIME        = "begin_time"
	END_TIME          = "end_time"
	STATUS            = "status"
	TASK_COUNT        = "task_count"
	DONE_COUNT        = "done_count"
	CREATED_AT        = "created_at"
	PLAN_STATUS       = "plan_status"
	TASK_STATUS       = "task_status"
	DONE_STATUS       = "done_status"
	MARKET_UID        = "market_uid"
	USER_UID          = "user_uid"
	USER_PROJECT_ROLE = "user_project_role"
	PROJECT_UID       = "project_uid"
	PROJECT_NAME      = "project_name"
	PROJECT_TYPE      = "project_type"
	PLAN_UID          = "plan_uid"
)

type UserProject struct {
	db.ModelUserPlace
	ProjectUID string `gorm:"type:char(32);index"`
}
type Project struct {
	db.ModelPlace
	CompanyUID string `gorm:"type:char(32);index"`
}
type Plan struct {
	Common
	TaskCount int `gorm:"default:0"`
}
type Task struct {
	Common
	PlanUID   string `gorm:"type:char(32);index"`
	DoneCount int    `gorm:"default:0"`
}
type Done struct {
	Common
	PlanUID string `gorm:"type:char(32);index"`
	TaskUID string `gorm:"type:char(32);index"`
}
type Todo struct {
	db.ModelContent
	ProjectUID string `gorm:"type:char(32);index"`
}
type Date struct {
	db.ModelContent
	ProjectUID string `gorm:"type:char(32);index"`
	Link       string `gorm:"type:varchar(255)"`
	BeginTime  db.Time
	EndTime    db.Time
}

func init() {
	db.CmdModels("", &UserProject{}, &Project{}, &Plan{}, &Task{}, &Done{}, &Todo{}, &Date{})
}

type Common struct {
	db.ModelContent
	ProjectUID  string `gorm:"type:char(32);index"`
	Status      uint8  `gorm:"default:0"`
	BeginTime   db.Time
	EndTime     db.Time
	ProcessTime db.Time
	FinishTime  db.Time
}
